#include "mview.h"
#include	<mm_alloc.h>
#include <stdio.h>
#include <string.h>
#include	"mail.h"


#define	KEYNUM	20
#define	MAILBOX_SET	1
#define	EDITOR_SET	2

static char	*catpack(char **head, char *dest, char *src);
int	GetEnvRc();

static char	*catpack(char **head, char *dest, char *src)
{
	*head = dest;

	while (*src)	*dest++ = *src++;
	*dest++ = '\0';

	return dest;
}

/* ǂݏo */
int	GetEnvRc()
{
	FILE	*fp;
	char	*r, *w, Temp[BUFMAX];
	char	Flag = 0;	/* K{ݒtO */
	static char	*envkey[KEYNUM] = {
			"MAILBOX", "KOED", "OPTION NAME", "SMAIL OPTION",
			"SIGNATURE NAME", "SIGNATURE FILE", "MIMEBOX",
			"FIRSTSEEK", "KOVIEW",
			"QUOTATION MARK", "DEFAULT SUBJECT", "DEFAULT REPLY",
			"DEFAULT CC", "SENTBOX", "REPLYHEAD", "RESOLVE",
			"XCC", "SORT", "DEFAULT CHARSET", "RULE"
	};

	ConsoleOpen();
	if (r = KoWindowGetEnv("MVIEWRC")) {
		strcpy(Temp, r);
	} else {
		PathGetExecDir(Temp);
		strcat(Temp, "MVIEW.RC");
	}

	{	int	size = fsize(Temp);
		if (size < 0) {
			ConsolePrintf("mview : t@C %s ܂\n", Temp);
			return FALSE;
		}
		Env.pack = malloc(size + 256);
	}

	if (!Env.pack)	ConsolePrint("mview : ܂\n");
	w = Env.pack;

	/* tO֌W̏ */
	Env.Qmark = NULL;
	Env.DefSubject = NULL;
	Env.Mimebox = NULL;
	Env.Sentbox = NULL;
	Env.Reply = NULL;
	Env.Cc = NULL;
	Env.replyhead = NULL;
	Env.xcc = NULL;
	Env.FilePutFlag = 0;
	Env.SeekFlag = 0;
	Env.resolve = FALSE;
	Env.sort = 0;
	Env.defconverter = jis2sjis;

	Env.SignatureNow = 0;
	w = catpack(&(Env.SignatureName[0]), w, "gȂ");

	Env.SmailNow = 0;
	w = catpack(&(Env.SmailName[0]), w, "ʏ푗M");
	w = catpack(&(Env.SmailOption[0]), w, "");

	Env.AutoMoveNow = 0;

	fp = fopen(Temp, "rt");
/*
	if (!fp) {
		ConsolePrintf("t@C %s ܂\n", Temp);
		return FALSE;
	}
*/
	/* t@Cǂœe */
	while (fgets(Temp, sizeof(Temp), fp)) {
		int	i = KEYNUM;

		/* ߂Ƌs͖ */
		if (Temp[0] == '#' || Temp[0] == '\n')	continue;

		while (--i >= 0) {
			if (r = GetKeyword(Temp, envkey[i]))	break;
		}

		switch (i) {
		case 0:	/* MAILBOX */
			strcat(r, "\\");
			w = catpack(&(Env.Mailbox), w, r);
			Flag |= MAILBOX_SET;
			break;
		case 1:	/* KOED */
		  {
			char	*tmp;

			for (tmp = r; *r > ' '; r++);
			if (*r)	*r++ = '\0';
			w = catpack(&(Env.Med), w, tmp);

			if (*r) {
				for (; *r && *r <= ' '; r++);
				for (tmp = r; *r; r++);
				*r++ = ' ';
				*r = '\0';
			}
			w = catpack(&(Env.edopt), w, tmp);
			Flag |= EDITOR_SET;
		  }
			break;
		case 2:	/* OPTION NAME */
			if (!Env.SmailNow)	Env.SmailNow = 1;
			w = catpack(&(Env.SmailName[Env.SmailNow]), w, r);
			break;
		case 3:	/* SMAIL OPTION */
			if (!Env.SmailNow)	Env.SmailNow = 1;
			w = catpack(&(Env.SmailOption[Env.SmailNow++]), w, r);
			break;
		case 4:	/* SIGNATURE NAME */
			if (!Env.SignatureNow)	Env.SignatureNow = 1;
			w = catpack(&(Env.SignatureName[Env.SignatureNow]), w, r);
			break;
		case 5:	/* SIGNATURE FILE */
			if (!Env.SignatureNow)	Env.SignatureNow = 1;
			w = catpack(&(Env.SignatureFile[Env.SignatureNow++]), w, r);
			break;
		case 6:	/* MIMEBOX */
			strcat(r, "\\");
			w = catpack(&(Env.Mimebox), w, r);
			break;
		case 7:	/* FIRSTSEEK */
			if (!strcmpi(r, "start"))	Env.SeekFlag = FALSE;
			else if (!strcmpi(r, "end"))	Env.SeekFlag = TRUE;
			break;
		case 8:	/* KOVIEW */
			viewinit(r);
			break;
		case 9:	/* QUOTATION MARK */
			w = catpack(&(Env.Qmark), w, r);
			break;
		case 10:	/* DEFAULT SUBJECT */
			w = catpack(&(Env.DefSubject), w, r);
			break;
		case 11:	/* DEFAULT REPLY */
			w = catpack(&(Env.Reply), w, r);
			break;
		case 12:	/* DEFAULT CC */
			w = catpack(&(Env.Cc), w, r);
			break;
		case 13:	/* SENTBOX */
			w = catpack(&(Env.Sentbox), w, r);
			break;
		case 14:	/* REPLYHEAD */
			w = catpack(&(Env.replyhead), w, r);
			break;
		case 15:	/* RESOLVE */
			Env.resolve = !strcmpi(r, "on");
			break;
		case 16:	/* XCC */
			w = catpack(&(Env.xcc), w, r);
			break;
		case 17:	/* SORT */
			Env.sort = !strcmpi(r, "time");
			break;
		case 18:	/* DEFAULT CHARSET */
			if (!strcmpi(r, "EUC")) {
				Env.defconverter = euc2sjis;
			} else if (strcmpi(r, "JIS")) {
				Env.defconverter = NULL;
			}
			break;
		case 19:	/* AUTOMOVE */
			w = catpack(&(Env.AutoMove[Env.AutoMoveNow++]), w, r);
			break;
		}
	}
	fclose(fp);
	if (Flag != (MAILBOX_SET|EDITOR_SET)) {
		ConsolePrint("mview : t@CɕK{ڂݒ肳Ă܂\n");
		return FALSE;
	}

	/* tO֌W̏ */
	if (!Env.Qmark)	w = catpack(&(Env.Qmark), w, "> ");
	if (!Env.DefSubject)	w = catpack(&(Env.DefSubject), w, "*NoTitle*");

	r = KoWindowGetEnv("TEMP");
	if (!r) {
		r = KoWindowGetEnv("temp");
		if (!r)	r = Env.Mailbox;
	}
	r = strcpy(Temp, r);
	while (*r) {
		if (*r == '/')	*r = '\\';
		r++;
	}
	w = catpack(&(Env.tempbox), w, Temp);

	realloc(Env.pack, (int)(w - Env.pack));
	return TRUE;
}
