#include	"mview.h"
#include	"mdir.h"
#include	"window.h"
#include	"address.h"
#include	"dialog.h"
/*#include	<stdlib.h>*/
#include	<mm_alloc.h>
#include	<io.h>
#include	<string.h>
/*#include	<sys_doslib.h>*/
#include	<doslib.h>

static int	smailopt(WindowID);	/* smail option I */
static void	sentmove();	/* Mσ[ړ */
static void	markclr();
static void	Remove();	/* 폜Tu[` */
static int	headcmp(char *str, char *key);


void
copymail( mail, dir, base )
MAILDATA	*mail;
char	*dir;
WindowID	base;
{
	int	i;
	char	comline[256], *ptr;

	i= dialog_open( mail->title, "ۑt@C", KEYIN, base );
	if( !i )	return;

	for( ptr= inputstr; *ptr; ptr++ ){
		if( *ptr == '/' )	*ptr= '\\';
	}
	sprintf( comline, "copy %s%s %s", dir, mail->filename, inputstr );

	i= WindowLoadExec( "command.x", comline, NULL, ConsoleChar );
	if( i ){
		mesprint( "[ۑɎs܂" );
	}else {
		mesprint( "[ۑ܂" );
	}
}


void
allmark()
{
	int	i;

	if (MarkNum) {
		for (i = 0; i < MailNow; i++)	MailOn[i] = FALSE;
		MarkNum= 0;
	} else {
		for (i = 0; i < MailNow; i++)	MailOn[i]= TRUE;
		MarkNum = MailNow;
	}
	WindowRedraw(Mwp);
}


/* ǁAɂ */
void
readmark()
{
	int	i;

	for (i = 0; i <= TargetNum; i++) {
		if (!(Mail[i].fileflag & M_CHECK)) {
			Mail[i].fileflag |= M_CHECK;
			SaveFlag = TRUE;
		}
	}
	WindowRedraw(Mwp);
}


void
quitop()
{
	int	i;

	WindowSendSignal(WindowProcessID, SignalKill, NULL);
	if (MailNow)	SaveInf();
	MailNow = 0;

	if (DirList) {
		for (i = 0; i < DirNow; i++) {
			free(DirList[i]);
		}
		free(DirList);
		DirList= NULL;
	}
	if (abook.Address)	{
		MFREE(abook.Address);
		abook.Address = NULL;
	}
	if (Mail) {
		MFREE(Mail);
		Mail = NULL;
	}
	if (MailOn) {
		MFREE(MailOn);
		MailOn = NULL;
	}

	if (Env.pack) {
		free(Env.pack);
		Env.pack = NULL;
	}
	WindowConnectionClose();
}

void
receive()
{
	WindowLoadExec( "spop.x", "", NULL, ConsoleChar );
	if( !SendFlag && !TrashFlag )	infupdate();
}

static int
smailopt(base)
WindowID	base;
{
	int	i;
	SUBINF	inf;

	if (!alloc_subwin(&inf, Env.SmailNow)) {
		return 0;
	}
	inf.SubWinBase = base;
	inf.WinMax = Env.SmailNow;
	for (i = 0; i < Env.SmailNow; i++) {
		strcpy(inf.WinMember[i].name, Env.SmailName[i]);
	}
	i = WinManager(&inf, "smail option", 0);	/* IȂ */
	free_subwin(&inf);

	return i;
}

static void
sentmove()
{
	if (Env.Sentbox) {
		char	MoveTargetDir[FILNMAX];

		strcpy(MoveTargetDir, Env.Mailbox);
		strcat(MoveTargetDir, Env.Sentbox);
		strcat(MoveTargetDir, "\\");
		if (strcmp(CDir, MoveTargetDir)) {
			Move( MoveTargetDir );
			return;
		}
	}
	infupdate();
}

static void
markclr()
{
	int	i;

	for (i = 0; i < MailNow; i++)	MailOn[i] = FALSE;
	MarkNum = 0;

	WindowRedraw(Mwp);
}


/* SM */
void
transmit_all(base)
WindowID	base;
{
	int	i;

	MarkNum = 0;
	for (i = 0; i < MailNow; i++)	MailOn[i]= TRUE;
	MarkNum = MailNow;

	transmit(base);
}


/* M */
void
transmit(base)
WindowID	base;
{
	FILE	*fp;
	DIALOGINF	*dinf;
	int	i, j;
	char	comline[256], tempname[128];

	if (!MarkNum) {
		MailOn[TargetNum] = TRUE;	/* J[\ʒu}[N */
		MarkNum = 1;
	}

	mesprint("[𑗐M܂");

	for (j = 0; j < MailNow; j++) {
		if (MailOn[j]) {
			if (Mail[j].fileflag & M_CHECK) {
				/* MςȂmFƂ */
				i = dialog_open(Mail[j].title, "[đM܂", YESNO, Bwp);
				if (!i) {
					MailOn[j] = FALSE;
					MarkNum--;
				}
			}
		}
	}

	/* smail optionI(S[) */
	if (Env.SmailNow) {
		i = smailopt(base);
		if (i < 0) {		/* ~ */
			markclr();
			return;
		}
	} else {
		i = 0;
	}

	strcpy(tempname, Env.tempbox);
	strcat(tempname, "mview.tmp");
	fp = fopen(tempname, "wt");
	if (!fp) {
		mesprint( "ꎞt@C쐬ł܂" );
		markclr();
		return;
	}

	dinf = (DIALOGINF*)dialog_open("", "ꎞt@C쐬",
									PROGRESS, Bwp);
	for (j = 0; j < MailNow; j++) {
		if (MailOn[j]) {
			fprintf(fp, "0 %s%s\n", CDir, Mail[j].filename);
		}
	}
	fclose(fp);

	dialog_print(dinf, "", "[𑗐MĂ܂");
	if (i) {
		sprintf(comline, "%s -P%s", Env.SmailOption[i], tempname);
	} else {
		sprintf(comline, "-P%s", tempname);
	}
	WindowLoadExec( "smail.x", comline, NULL, ConsoleChar );

	fp = fopen(tempname, "rt");
	if (!fp) {
		mesprint("ꎞt@Cǂ߂܂");
		markclr();
		return;
	}

	for (j = 0; j < MailNow; j++) {
		if (MailOn[j]) {
			fgets(comline, 256, fp);
			if (comline[0] == '1') {
				if (!(Mail[j].fileflag & M_CHECK)) {
					Mail[j].fileflag |= M_CHECK;
					SaveFlag = TRUE;
				}
			} else {
				MailOn[j] = FALSE;
				if (!MarkNum--)	break;
			}
		}
	}
	fclose(fp);
	remove(tempname);

	dialog_close(dinf);
	if (MarkNum) {
		mesprint("[𑗐M܂");
		if (SendFlag == 2)	sentmove();	/* I[gړ */
	} else {
		mesprint("[𑗐Mł܂ł");
		WindowRedraw(Mwp);
	}
}


void
delop(force)
int	force;
{
	char	MoveTargetDir[256];

	if (force || SendFlag == 2 || TrashFlag) {
		/* SendTrashł͖{ɏ */
		if (dialog_open("", "[폜܂", YESNO, Bwp))
			Remove();
	} else {
		/* TrashfBNgɈړ */
		if(dialog_open("", "[ݔɈړ܂", YESNO, Bwp)) {
			if (!MarkNum) {
				/* J[\ʒu}[N */
				MailOn[TargetNum]= TRUE;
				MarkNum= 1;
			}
			strcpy(MoveTargetDir, Env.Mailbox);
			strcat(MoveTargetDir, "Trash\\");
			Move(MoveTargetDir);
		}
	}
}


static void
Remove()
{
	int	i, t;
	DIALOGINF	*dinf;
	char	FileName[FILNMAX];

	if (!MarkNum) {
		/* J[\ʒu}[N */
		MailOn[TargetNum] = TRUE;
	}

	dinf = (DIALOGINF*)dialog_open("", "", PROGRESS, Bwp);
	mesprint("[폜");
	for (t = 0, i = 0; i < MailNow; i++) {
		if (MailOn[i]) {
			/* CDir/i 폜 */
			dialog_print(dinf, Mail[i].title, "폜Ă܂");
			strcpy(FileName, CDir);
			strcat(FileName, Mail[i].filename);
			if (remove(FileName) == -1) {
				mesprint("[폜ł܂");
				if (t != i) {			/* ʔԂɋl߂ */
					Mail[t] = Mail[i];	/* f[^ړ */
					MailOn[t] = TRUE;
				}
				t++;
			}
		} else {
			if (t != i) {			/* ʔԂɋl߂ */
				Mail[t] = Mail[i];	/* f[^ړ */
				MailOn[t] = FALSE;
			}
			t++;
		}
	}

	/* ړ[ʂ炷 */
	dialog_print(dinf, "MLlist2.INF", "XVĂ܂");
	rewriteinf(t);
	dialog_close(dinf);
}

void
infupdate()
{
	extern int	MailExec(WindowID, EventInfo*);

	if (MailNow)	SaveInf();
	FILEGET();
	WindowClose(Mwp);
	Mwp= WindowScrollOpen(120, 0 + BUTTON_V, 392, 244, Bwp, 392,
						(MailNow * FONT_V <= 240)? 240:MailNow * FONT_V,
						DirectionY, 16, FONT_V, MailExec);
	if (!MailNow)	Dir= 0;
}

void
mailsort(filename, mail, mailnum)
char	*filename;
MAILDATA	*mail;
int	mailnum;
{
	int	i = -1;
	MAILDATA	**ptr;
	FILE	*fp;

	fp = fopen(filename, "wb");
	if (!fp) {
		mesprint("MLlist2.INF쐬ł܂");
		return;
	}
	fwrite(&mailnum, sizeof(int), 1, fp);

	if (ptr = malloc(mailnum * sizeof(MAILDATA*))) {
		/* |C^z쐬 */
		for (i = 0; i < mailnum; i++) {
			ptr[i] = &(mail[i]);
		}

		i = pqsort(ptr, mailnum);
		if (i >= 0) {
			if (Env.sort) {
				/* ~\[g */
				for (i = mailnum - 1; i >= 0; i--) {
					fwrite(ptr[i], sizeof(MAILDATA), 1, fp);
				}
				i = 0;
			} else {
				/* \[g */
				for (i = 0; i < mailnum; i++) {
					fwrite(ptr[i], sizeof(MAILDATA), 1, fp);
				}
			}
		}
		free(ptr);
	}
	if (i < 0) {
		mesprint("\[gp܂");
		fwrite(mail, sizeof(MAILDATA), mailnum, fp);
	}
	fclose(fp);
}

static int
headcmp(char *str, char *key)
{
	while (*key) {
		if (*str++ != *key++) {
			return FALSE;
		}
	}
	return TRUE;
}

void
AutoMove()
{
	int	i, j;
	char	temp[256];

	for (i = 0; i < Env.AutoMoveNow; i++) {
		char	*r, *w;

		r = Env.Mailbox;
		w = temp;
		while (*r)	*w++ = *r++;

		r = Env.AutoMove[i];
		while (*r && *r != '\t')	*w++ = *r++;
		if (!*r++)	break;
		*w++ = '\\';
		*w = '\0';

		w = r;
		while (*r && *r != '\t')	r++;
		if (!*r)	break;
		*r++ = '\0';
		if (strcmpi(w, "SUBJECT:"))	break;

		MarkNum = 0;
		for (j = 0; j < MailNow; j++) {
			if (headcmp(Mail[j].title, r)) {
				MailOn[j] = TRUE;
				MarkNum++;
			} else {
				MailOn[j] = FALSE;
			}
		}
		if (MarkNum)	Move(temp);
	}
	infupdate();
}
