#include	"mview.h"
#include	<io.h>
/*#include	<stdlib.h>*/
#include	<string.h>
/*#include	<sys_doslib.h>*/
#include	<doslib.h>
/*#include	<isa/isalib.h>*/

static int	maxmail = 0; 
static char	*Month[12]= {	"Jan", "Feb", "Mar", "Apr",
							"May", "Jun", "Jul", "Aug",
							"Sep", "Oct", "Nov", "Dec" };
static char	MonthName[12] = { 'G', 'F', 'H', 'A', 'M', 'W',
							 'J', 'E', 'S', 'O', 'N', 'D' };

extern char	decode_mime(char*, char*);

static int	alloc_mail(int);
static int	readmailinf();
static void	MailTempInit(MAILDATA*);
static void	ReinfofSend();


static int
alloc_mail(size)
int	size;
{
	if (maxmail >= size)	return TRUE;

	if (Mail)	MFREE(Mail);
	if (MailOn)	MFREE(MailOn);

	if (size < MAILMAX) {
		maxmail = MAILMAX;
	} else {
		maxmail = size;
	}
	Mail = MALLOC2(1, sizeof(MAILDATA) * maxmail);
	if ((int)Mail < 0) {
		Mail = NULL;
	} else {
		MailOn = MALLOC2(1, sizeof(char) * maxmail);
		if ((int)MailOn < 0) {
			MFREE(Mail);
			Mail = NULL;
		}
	}

	if (!Mail) {
		MailOn = NULL;
		maxmail = 0;
		mesprint("[p̃mۂł܂\n");
		return FALSE;
	}
	return TRUE;
}

int
readmailinf()
{
	short	fn;
	unsigned char	INFFile[256];

	MailNow = 0;					/* [ */

	strcpy(INFFile, CDir);
	strcat(INFFile, MAILLIST);

	fn = OPEN(INFFile, 0);
	if (fn < 0) {					/* MAILLISTȂ */
		if (!alloc_mail(MAILMAX))	return -1;
	}else {
		READ(fn, &MailNow, 4);	/* MAILLISTǂݍ */
		if (!MailNow) {				/* [ȂΖ߂ */
			CLOSE(fn);
			if (!alloc_mail(MAILMAX))	return -1;
			return 0;
		} else if (!alloc_mail(MailNow * 2)) {
			CLOSE(fn);
			MailNow = 0;
			return -1;
		}
		READ(fn, Mail, sizeof(MAILDATA) * MailNow);
		CLOSE(fn);
	}
	return MailNow;
}

/* [̎擾B܂MAILLISTTAȂ΍쐬 */
void
FILEGET()
{
	int i;

	TargetNum= 0;
	MarkNum= 0;
	SaveFlag = FALSE;

	mesprint( "[ꗗ" );
	i= readmailinf();
	if (i < 0)	return;
	if (i && SendFlag == 2)	ReinfofSend();

	MakeInf();				/* [ */
	for (i = 0; i < MailNow; i++) {
		MailOn[i] = FALSE;	/* }[N */
	}

	/* seekflagݒ肪΁AJ[\𖖒[ */
	if (Env.SeekFlag && MailNow)	TargetNum = MailNow - 1;

	/* J[\𖢓ǁEMʒu */
	for (i = 0; i < MailNow; i++) {
		if (!(Mail[i].fileflag & M_CHECK)) {
			/* (̐擪) */
			TargetNum = i;
			break;
		}
	}
}

void
MakeInf()
{
	MAILDATA	*MailTemp;
	FILE	*fp;
	int	i, SpoolNow= 0;
	char	GetFlag,	/* wb_EH */
			FromFlag, *Temp,
			filename[128], TempStr[1024];

	ConsoleOpen();

	GetNewName(NULL, NULL);
	while (1) {
		if (MailNow >= maxmail) {
			if (SpoolNow)	SaveFlag = TRUE;
			SaveInf();
			if (readmailinf() < 0)	return;
		}
		MailTemp = &(Mail[MailNow]);

		sprintf( TempStr, "%s%d", CDir, SpoolNow );
		if( !( fp= fopen( TempStr, "rt" ) ) )	break;

	/* oOɏ */
		strcpy(filename, TempStr);	/* t@Ĉݎ擾 */
		MailTemp->title[0]= '\0';
		MailTemp->name[0]= '\0';
		MailTemp->year[0]= '\0';
		MailTemp->time[0]= '\0';
		MailTemp->fileflag= 0;
		if( SendFlag == 2 ){
			MailTempInit( MailTemp );
		}else {
			MailTemp->year_v= 0;
			MailTemp->time_v= 0;
		}

		GetFlag= 0;
		FromFlag = FALSE;

		/* 邾̃f[^Bswb_ĨTC */
		while (fgets822a(TempStr, sizeof(TempStr), fp)) {
			decode_mime(TempStr, TempStr);

			if( Temp= GetKeyword( TempStr, "SUBJECT:" ) ){ /* ^Cg擾 */
				GetFlag++;
				strcpy( MailTemp->title, CutStr2( Temp, MSUBJECT_MAX ) );
				continue;
			}

			if ((!SendFlag && (Temp = GetKeyword(TempStr, "FROM:")))
					|| (SendFlag && (Temp = GetKeyword(TempStr, "TO:")))) {
				FromFlag = TRUE;
				GetFlag++;
				/* O擾 */
				extract_name(MailTemp->name, Temp, MNAME_MAX);
				continue;
			}

			 /* Return-Path擾(FromȂɑp) */
			if (!FromFlag && (Temp = GetKeyword(TempStr, "RETURN-PATH:"))) {
				char	*w = TempStr;

				GetFlag++;
				 /* Return-xx<̎ */
				while (*Temp && *Temp != '<')	Temp++;
				if (Temp)	Temp++;
				/* O𒊏o */
				while (*Temp && *Temp != '>')	*w++ = *Temp++;
				*w = '\0';
				strcpy(MailTemp->name, CutStr2(TempStr, MNAME_MAX));
				continue;
			}

			/* t̎擾 */
			if( Temp= GetKeyword( TempStr, "DATE:" ) ){
				int	date, year;
				char	*month, *time,
						*time0, *time1, *time2;

				GetFlag++;
				strcpy( TempStr, Temp );	/* Date: ̎𒊏o */

				/* jꍇ̓J}̌Ȃ̂ł炷 */
				if( Temp= strchr( TempStr, ',' ) ){
					Temp+= 1;
				}else {
					Temp= TempStr;
				}

				/* g[NŊēo */
				date= atoi2( strtok( Temp, " " ) );
				month= strtok( NULL, " " );
				year= atoi2( strtok( NULL, " " ) );
				time= strtok( NULL, " " );
				time[8]= '\0';

				if( year < 100 ){	/* QȂ␳ */
					if (year >= 70) {
						year += 1900;
					} else {
						year += 2000;
					}
				}

				for( i= 0; i < 12; i++ ){
					if( !strcmp( month, Month[i] ) ) break;
				}
				i++;
				sprintf( MailTemp->year, "%4.4d-%2.2d-%2.2d", year, i, date );

				/* r̂߂̌vZ */
				MailTemp->year_v = year;
				MailTemp->year_v = MailTemp->year_v * 100 + i;
				MailTemp->year_v = MailTemp->year_v * 100 + date;

				if( !strchr( time, ':' ) ){
					/* ΉĂȂł00:00:00ŕ] */
					MailTemp->time_v= 0;
					strcpy( MailTemp->time, "00:00:00" );
				}else {
					strcpy( MailTemp->time, time );
					time0= strtok( time, ":" );
					time1= strtok( NULL, ":" );
					time2= time + 6;
					MailTemp->time_v= atoi2( time0 ) * 10000
										+ atoi2( time1 ) * 100 + atoi2( time2 );
				}
				continue;
			}else if( strstr( TempStr, "boundary=" ) ){
				/* wb_ boundary= ΃NbvtOON */
				MailTemp->fileflag |= M_CLIP;
			}

		}
		fclose( fp );
		MailTemp->type= 1;
		if( GetFlag > 1 - SendFlag ){
			/* 擾wb_eQȏȂ烁[ƂĔF߂B
				SendFlag΂Pŕs */
			Temp= GetNewName( CDir, MailTemp );
			strcpy( TempStr, CDir );
			strcat( TempStr, Temp );
			if( rename(filename, TempStr) < 0 ){	/* ړs */
				mesprint( "Xv[烁[ڂ܂" );
				return;
			}
			strcpy(MailTemp->filename, Temp);
			MailOn[MailNow++]= 0;
		}else {
			mesprint( "FłȂ[܂" );
			break;
		}
		SpoolNow++;
		mesprint( "V[擾" );
	}
	/* [ SaveInf() ŃZ[u\ */
	if (SpoolNow)	SaveFlag = TRUE;
}

static void
MailTempInit( MailTemp )
MAILDATA	*MailTemp;
{
	int	temp, i, j, k;

	/* Sendt@C̏ꍇADate:Ȃ̂ŌݎZbgĂ */
	temp= GETDATE();
	i= ( ( ( temp >> 9 ) & 127 ) % 100 ) + 1980;
	j= ( temp >> 5 ) & 15;
	k= temp & 31;

	sprintf( MailTemp->year, "%4.4d-%2.2d-%2.2d", i, j, k );

	/* r̂߂̌vZ */
	MailTemp->year_v= i * 10000 + j * 100 + k;

	temp= GETTIM2();
	i= ( temp >> 16 ) & 31;
	j= ( temp >> 8 ) & 63;
	k= temp & 63;
	
	sprintf( MailTemp->time, "%2.2d:%2.2d:%2.2d", i, j, k );

	MailTemp->time_v= i * 10000 + j * 100 + k;
}

/*	SENDnfBNgMAILLIST蒼 */
void
ReinfofSend()
{
	int	GetFlag;
	int	j;
	FILE	*fp;
	char	 *Temp, TempStr[BUFMAX];
	MAILDATA	mailtemp;

	mesprint("[XV");
	for (j = 0; j < MailNow; j++) {
		strcpy(TempStr, CDir);
		strcat(TempStr, Mail[j].filename);
		if (!(fp = fopen(TempStr, "rt")))	continue;

		GetFlag = 0;

		/* 邾̃f[^Bswb_ĨTC */
		while (fgets822a(TempStr, sizeof(TempStr), fp)) {
			decode_mime(TempStr, TempStr);

			/* From, To `FbNςsŒI */
			if (GetFlag > 1 || TempStr[0] == '\n')	break;

			/* ^Cg擾 */
			if (Temp = GetKeyword(TempStr, "SUBJECT:")) {
				GetFlag++;
				CutStr2(Temp, MSUBJECT_MAX);
				if (strcmp(Mail[j].title, Temp)) {
					strcpy(Mail[j].title, Temp);
					SaveFlag = TRUE;
				}
				continue;
			}

			/* O擾 */
			if (Temp = GetKeyword(TempStr, "TO:")) {
				GetFlag++;
				extract_name(mailtemp.name, Temp, MNAME_MAX);
				if (strcmp(Mail[j].name, mailtemp.name)) {
					strcpy(Mail[j].name, mailtemp.name);
					SaveFlag = TRUE;
				}
				continue;
			}
		}
		fclose(fp);
	}
}

/* MLlist2.INFZ[u */
void
SaveInf()
{
	unsigned char	INFFile[FILNMAX];

	/* Z[uKvȂ΂܂ */
	if (!SaveFlag)	return;
	SaveFlag = FALSE;

	strcpy(INFFile, CDir);
	strcat(INFFile, MAILLIST);
	mailsort(INFFile, Mail, MailNow);
}

/* fBNgƁA[̓tƂɃt@C쐬 */
char *
GetNewName( DIR, mail )
char	*DIR;
MAILDATA	*mail;
{
	static int	oldyear, brandnew;
	static char	OpenTestName[256];

	int	Num;
	char	*FileName, *tmp, *rptr;
	FILE	*fp;

	if( !DIR ){
		oldyear= -1;
		brandnew= 0;
		return NULL;
	}

	tmp= strcpy( OpenTestName, DIR );
	for( ; *tmp; tmp++ );
	FileName= tmp;

	*tmp++= mail->year_v / 1000000 + 'A';	/* W */
	rptr= mail->year + 2;
	*tmp++= *rptr++;		/* N̉Q擾 */
	*tmp++= *rptr;

	rptr+= 2;
	Num= 0;
	while( *rptr != '-' ){	/* 擾 */
		Num*= 10;
		Num+= *rptr++ - '0';
	}
	*tmp++= MonthName[Num - 1];

	rptr++;
	Num= 0;
	while( *rptr ){	/* 擾 */
		Num*= 10;
		Num+= *rptr++ - '0';
	}
	if( Num < 10 ){
		*tmp++= '0';
	}else {
		*tmp++= Num / 10 + '0';
		Num= Num % 10;
	}
	*tmp++= '0' + Num;

	tmp+= 2;
	*tmp++= '.';
	*tmp++= 'M';
	*tmp++= 'L';
	*tmp= '\0';

	if( mail->year_v != oldyear ){
		oldyear= mail->year_v;
		brandnew= 0;
	}
	Num= brandnew;

	while (1) {		/* Vt@C𔭌܂ő */
		static char	chrtbl[] = "0123456789ABCDEFGHIJKLMNOPQRSTUV";

		if (Num >= 1024) {
			FileName[8] = chrtbl[Num >> 10];
			strcpy(FileName + 9, ".ML");
		}
		FileName[6] = chrtbl[(Num >> 5) & 31];
		FileName[7] = chrtbl[Num & 31];

		/* `FbN...t@CȂ΂nj */
		if (!(fp = fopen(OpenTestName, "rt")))	break;

		/* t@CΌJԂ */
		fclose (fp);
		Num++;
	}
	brandnew= Num;
	return FileName;
}
