#include	"mview.h"
#include	"mdir.h"
#include	"mime.h"
#include	<HS_wlib.h>
#include	<winop.h>
#include	<string.h>

extern void	Formatstring( char*, MAILDATA* );

static void	DragMove( WindowID, EventInfo* );
static int	popupmenu( WindowID, EventInfo* );
void	markop( WindowID, int );
int	MailExec( WindowID, EventInfo* );

#include	"Let.c"
/*#include	"rmtable.c"*/

/*
Sheet	*shttbl[]= {
	&Let1Pattern,
	&Let2Pattern,
	&Let3Pattern,
	&Let4Pattern,
	&Let5Pattern
};
*/

static char	*menu[]= {
			"@{",
			"ԐM쐬",
			"  ]",
			"VK쐬",
			"",
			"",
			"@ۑ",
			"@ړ",
			"@폜",
			"\XV",
			"S}[N"
};
static char	*sendmenu[]= {
			"@{",
			"@ҏW",
			"",
			"VK쐬",
			"@Yt",
			"@M",
			"@ۑ",
			"@ړ",
			"@폜",
			"\XV",
			"S}[N"
};

static unsigned int	work= 0;


void
DragMove( wp, info )
WindowID	wp;
EventInfo	*info;
{
	char	MoveTargetDir[STR_MAX];
	WindowID	cwp;
	int	my_y;
	
	MouseSetDefPat_TUKAMI();
	while( !(WindowGetEventInfo(info) && info->LeftOFF) );
	cwp= WindowGetChild( WindowRootID, info );
	MouseSetNormalPat();
	if (cwp == Bwp) {
		info->y -= BUTTON_V;
		cwp = WindowGetChild(Bwp, info);
		if (cwp == Dwp) {
			my_y = info->y / 12;
			if (my_y < DirNow) {
				strcpy(MoveTargetDir, Env.Mailbox);
				strcat(MoveTargetDir, dirdescend(DirList[my_y]));
				strcat(MoveTargetDir, "\\");
				if (strcmp(CDir, MoveTargetDir)) {
					Move(MoveTargetDir);
				}
			}
		}
	}
}


void
markop( wp, y )
WindowID	wp;
int	y;
{
	DrawBuf	dbuf[4], *dp= dbuf;
	char	sbuf[2][62];
	int	attr, fileflag;

	if( TargetNum != y ){
		attr= (MailOn[TargetNum])? (AttrDefault ^ 8):AttrDefault;
		fileflag= Mail[TargetNum].fileflag & 3;
		if( SendFlag )	fileflag|= 4;
		DrawSetPut( dp++, 0, TargetNum * 12, &(LetPattern[fileflag]) );
		Formatstring( sbuf[0], &(Mail[TargetNum]) );
		DrawSetSymbol( dp++, 12, TargetNum * 12, sbuf[0], attr, 12 );
	}

	attr= AttrDefault|AttrUnderLine;
	if ( MailOn[y] ) {	/* }[N*/
		MarkNum--;
		MailOn[y]= 0;
	} else {			/* }[Nt */
		MarkNum++;
		MailOn[y]= 1;
		attr^= 8;
	}

	fileflag= Mail[y].fileflag & 3;
	if( SendFlag )	fileflag|= 4;
	DrawSetPut( dp++, 0, y * 12, &(LetPattern[fileflag]) );
	Formatstring( sbuf[1], &(Mail[y]) );
	DrawSetSymbol( dp++, 12, y * 12, sbuf[1], attr, 12 );
	WindowDraw( wp, dbuf, dp - dbuf );

	TargetNum= y;
	return;
}

static int
popupmenu(wp, info)
WindowID	wp;
EventInfo	*info;
{
	int	num, px, py;
	char	**curmenu;
	
	curmenu = (SendFlag)? sendmenu:menu;
	WindowGetScreenPosition(wp, &px, &py);
	px += info->x;
	py += info->y - HS_WindowGetHomeY(wp);

	num = PopUpMenu(px-1, py, curmenu, sizeof menu/sizeof(char*), 12);
	switch (num) {
	case 0:		/*{*/
		info->KeyCode = 'v';
		break;
	case 1:		/*ԐM or ҏW*/
		if (SendFlag) {
			info->KeyCode = 'e';
		} else {
			info->KeyCode = 'f';
		}
		break;
	case 2:		/*]*/
		if (SendFlag)	return TRUE;
		info->KeyCode = 'F';
		break;
	case 3:		/*VK*/
		info->KeyCode = 'w';
		break;
	case 4:		/*Yt*/
		if (SendFlag) {
			info->KeyCode = 'x';
			break;
		} else {
			return TRUE;
		}
	case 5:		/*M*/
		if (SendFlag) {
			info->KeyCode = 's';
			break;
		} else {
			return TRUE;
		}
	case 6:
		info->KeyCode = 'c';
		break;
	case 7:		/*ړ*/
		info->KeyCode = 'm';
		break;
	case 8:		/*폜*/
		info->KeyCode = 'd';
		break;
	case 9:		/*XV*/
		info->KeyCode = FuncKeyClr;
		break;
	case 10:	/*S}[N*/
		info->KeyCode = 'a';
		break;
	default:
		return TRUE;
	}
	info->option = EventKey;
	WindowSendEvent(Bwp, info);
	return TRUE;
}


int
MailExec(wp, info)
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[22 * 2 + 2], *dp = dbuf;
	char	sbuf[22][62];
	int	y;

	switch(info->option) {
	case EventOpen:
		WindowSetEventAttr(wp, EventAttrDefault);
		DrawSetLine(dp++, BUTTON_H + 20, 6, BUTTON_H + 20 + FONT_H * 23 - 1,
						6 + FONT_V - 1, 1, OptionFill);
		DrawSetSymbol(dp++, BUTTON_H + 20, 6, DirList[DirPos]->optname,
						AttrDefault, 12);
		WindowDraw(Bwp, dbuf, dp - dbuf);
		y = HS_WindowGetHomeY(wp) / 12;
		if (TargetNum < y || TargetNum >= y + 20) {
			if (MailNow - TargetNum < 20) {
				y = MailNow - 20;
			} else {
				y = TargetNum;
			}
			WindowSetHome(wp, 0, y * 12);
		}
		WindowRedraw(wp);
		return TRUE;

	case EventRedraw:
	{
		int	j, attr, fileflag;
		y = HS_WindowGetHomeY(wp) / 12;
		if (TargetNum < y || TargetNum >= y + 20)	TargetNum = y;
		if (MailNow < 20)	DrawSetClear(dp++, 1);
		if (y)	y -= 1;
		for (j = 0; y < MailNow && j < 22; y++, j++) {
			attr = (MailOn[y])? (AttrDefault ^ 8):AttrDefault;
			if (y == TargetNum)	attr |= AttrUnderLine;
			fileflag = Mail[y].fileflag & 3;
			if (SendFlag)	fileflag |= 4;
			DrawSetPut(dp++, 0, y * 12, &(LetPattern[fileflag]));
			Formatstring(sbuf[j], &(Mail[y]));
			DrawSetSymbol(dp++, 12, y * 12, sbuf[j], attr, 12);
		}
		WindowDraw(wp, dbuf, dp - dbuf);
		return TRUE;
	}

	case EventClose:
		WindowClose(wp);
		return TRUE;

	case EventMouseSwitch:{
		y = info->y / 12;

		DrawSetLine(dbuf, 0, 242 + 4 + BUTTON_V,  511, 254 + BUTTON_V, 1, OptionFill);
		WindowDraw(Bwp, dbuf, 1);
		if (y < MailNow) {
			if (info->RightON) {
				TargetNum = y;
				WindowRedraw(wp);
				popupmenu(wp, info);
			} else if (info->LeftON) {
				unsigned int	t = IntervalTime();
				if (info->x <= 16) {
					TargetNum = y;
					WindowRedraw(wp);
					ReadMail();
				} else {
					markop(wp, y);
					if (t - work < 30) {
						ReadMail();
					} else if (MarkNum) {
						DragMove(wp, info);
					}
				}
				work = t;
				return TRUE;
			}
		} else {
			if (info->RightON)	popupmenu(wp, info);
		}
		return TRUE;
	}
	}
	return FALSE;
}
