#include	"mview.h"
#include	"window.h"
#include	<HS_wlib.h>
#include	<io.h>
#include	<string.h>
/*#include	<sys_doslib.h>*/
#include	<doslib.h>
#include	<iocslib.h>

#define		Ctrl(a)	((a)&0x1f)
#define		CFN(a)	((a)|0x200)
#define		Esc(a)	((a)|0x100)

static void	WinMark( WindowID, int, SUBINF* );
static void	cursormove( WindowID, int, SUBINF* );
static int	WinKey( WindowID, EventInfo*, SUBINF* );
static int	WinScExec( WindowID, EventInfo* );
static int	WinExec( WindowID, EventInfo* );


int
alloc_subwin( inf, size )
SUBINF	*inf;
int	size;
{
	inf->WinMember= MALLOC2( 1, sizeof( WINMEMBER ) * size );
	if( (int)(inf->WinMember) < 0 ){
		inf->WinMember= NULL;
		mesprint( "SubWiñmۂł܂" );
		return FALSE;
	}
	return TRUE;
}

void
free_subwin( inf )
SUBINF	*inf;
{
	if( inf->WinMember ){
		MFREE( inf->WinMember );
		inf->WinMember= NULL;
	}
	return;
}

static void
WinMark( wp, i, inf )
WindowID	wp;
int	i;
SUBINF	*inf;
{
	DrawBuf	dbuf[2], *dp= dbuf;
	int	attr;

	if( inf->OnSwitch ){			/* I */
		attr= (inf->WinMember[inf->TargetMen].On)? (AttrDefault ^ 8):AttrDefault;
		DrawSetSymbol( dp++, 0, inf->TargetMen * 12,
						inf->WinMember[inf->TargetMen].name, attr, 12 );
		attr= AttrDefault | AttrUnderLine;
		if( inf->WinMember[i].On ){
			inf->WinMember[i].On= 0;
			inf->WinOnNum--;
		}else {
			inf->WinMember[i].On= 1;
			inf->WinOnNum++;
			attr^= 8;
		}
		DrawSetSymbol( dp++, 0, i * 12, inf->WinMember[i].name, attr, 12 );
	}else {
		inf->WinMember[inf->TargetMen].On= 0;
		inf->WinMember[i].On= 1;
		DrawSetSymbol( dp++, 0, inf->TargetMen * 12,
					 inf->WinMember[inf->TargetMen].name, AttrDefault, 12 );
		DrawSetSymbol( dp++, 0, i * 12, inf->WinMember[i].name,
					AttrDefault ^ 8, 12 );
	}
	inf->TargetMen= i;
	WindowDraw( wp, dbuf, dp - dbuf );
}


static void
cursormove( wp, y, inf )
WindowID	wp;
int	y;
SUBINF	*inf;
{
	if( !inf->OnSwitch ){
		WinMark( wp, y, inf );
	}else {
		DrawBuf	dbuf[2], *dp= dbuf;
		int	attr, i= 2;

		attr= AttrDefault;
		while( i-- ){
			if( inf->WinMember[inf->TargetMen].On )	attr^= 8;
			DrawSetSymbol( dp++, 0, inf->TargetMen * 12,
							inf->WinMember[inf->TargetMen].name, attr, 12 );

			inf->TargetMen= y;
			attr= AttrDefault | AttrUnderLine;
		}
		WindowDraw( wp, dbuf, dp - dbuf );

	}
}


/* L[샋[` */
static int
WinKey( wp, info, inf )
WindowID wp;
EventInfo *info;
SUBINF	*inf;
{
	unsigned int Key= info->KeyCode;
	int	i, y;

	y= HS_WindowGetHomeY( wp ) / 12;
	if( Key >= FuncKey && (info->ShiftStat & 2) )
		Key |= 0x200;

	switch( Key ){
	case FuncKeyUp:
	case Ctrl('e'):
	case Ctrl('p'):
		if( inf->TargetMen ){	/* uv */
			i= 	inf->TargetMen - 1;
			cursormove( wp, i, inf );
			if( inf->WinMax > 15 && i < y ){
				/* 炵ĂXN[ */
				WindowScroll( wp, 0, -12 );
			}
		}
		break;

	case ' ':			/* }[N */
		if( !inf->OnSwitch )	break;
		WinMark( wp, inf->TargetMen, inf );

	case FuncKeyDown:
	case Ctrl('n'):
	case Ctrl('x'):
		i= inf->TargetMen + 1;
		if ( i < inf->WinMax ) {	/* uv */
			cursormove( wp, i, inf );
			if( inf->WinMax > 15 && i >= y + 15 ){
				/* 炵ĂXN[ */
				WindowScroll( wp, 0, 12 );
			}
		}
		break;

	case FuncKeyRollDown:	/* uROLL DOWNv */
	case Ctrl( 'r' ):
	case Ctrl( 'z' ):
		if( inf->TargetMen ){
			i= inf->TargetMen - 14;
			if( i < 0 ){	/* Eяo␳ */
				i= 0;
			}
			cursormove( wp, i, inf );
			if( y && inf->WinMax > 15 ){ /* [? */
				WindowScroll( wp, 0, -12 * 14 );	/* Py[Wړ */
			}
		}
		break;

	case FuncKeyRollUp:		/* uROLL UPv */
	case Ctrl('v'):
	case Ctrl('c'): 
		if( inf->TargetMen != inf->WinMax - 1 ){
			i= inf->TargetMen + 14;
			if( i >= inf->WinMax ){	/* Eяo␳ */
				i = inf->WinMax - 1;
			}
			cursormove( wp, i, inf );
			if( inf->WinMax > 15 && y + 15 <=  inf->WinMax ){/* I[? */
				WindowScroll( wp, 0, 12 * 14 );	/* Py[Wړ */
			}
		}
		break;
	}
	return TRUE;
}


static int
WinScExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[15 + 2 + 1], *dp= dbuf;
	int	i;
	SUBINF	*inf= WindowGetClientPointer( HS_WindowGetParent( wp ) );
	switch( info->option ){
	case EventOpen:
		for( i= 0; i < inf->WinMax; i++ )	inf->WinMember[i].On= 0;
		inf->TargetMen= 0;	/* 0ԂftHgőI */
		if( !inf->OnSwitch ){
			inf->WinOnNum= 1;
			inf->WinMember[0].On= 1;	/* }[N */
		}
		inf->Swp= wp;
		return TRUE;
	case EventRedraw:
	{
		int	j, attr;

		DrawSetClear( dp++, 1 );
		i= HS_WindowGetHomeY( wp ) / 12;
		if( inf->TargetMen < i || inf->TargetMen >= i + 15 ){
			if( !inf->OnSwitch ){
				inf->WinMember[inf->TargetMen].On= 0;
				inf->WinMember[i].On= 1;
			}
			inf->TargetMen= i;
		}
		if( i )	i-= 1;
		for( j= 0; i < inf->WinMax && j < 15 + 2; i++, j++ ){
			attr= ( inf->WinMember[i].On )? (AttrDefault ^ 8):AttrDefault;
			if( i == inf->TargetMen ) attr|= AttrUnderLine;
			DrawSetSymbol( dp++, 0, i * 12, inf->WinMember[i].name,
							attr, 12 );
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		return TRUE;
	}
	case EventClose:
		WindowClose( wp );
		return TRUE;

	case EventMouseSwitch:
		if( info->LeftON && (i= info->y / 12) < inf->WinMax ){
			WinMark( wp, i, inf );
		}
		return TRUE;
	}
	return FALSE;
}

static int
WinExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[5 + 2], *dp= dbuf;
	SUBINF	*inf;

	inf= WindowGetClientPointer( wp );
	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EventAttrDefault );
		return	TRUE;
	case EventClose:
		WindowClose( inf->Swp );
		WindowClose( wp );
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		DrawSetLine( dp++, 0, 0, 149, 12, 0, OptionFill );
		DrawSetSymbol( dp++, 0, 1, inf->subtitle, 3, 12 );
		DrawSetSymbol( dp++, 18, 184 + 4 + 14, "  Ok  ", AttrDefault, 12 );
		DrawSetSymbol( dp++, 98, 184 + 4 + 14, "Cancel", AttrDefault, 12 );
		DrawSetLine( dp++, 16, 182 + 4 + 14,  55, 197 + 4 + 14, ShadowUp, OptionShadow );
		DrawSetLine( dp++, 96, 182 + 4 + 14, 135, 197 + 4 + 14, ShadowUp, OptionShadow );
		WindowDraw( wp, dbuf, dp - dbuf );
		WindowRedraw( inf->Swp );
		return	TRUE;
	case EventMouseSwitch:
		if( info->y >= 14 && info->y < 184 + 14){
			info->y -= 14;
			return WindowSendEvent( inf->Swp, info );
		}
		return TRUE;
	case EventKey:
		info->y -= 14;
		return WinKey( inf->Swp, info, inf );
	}
	return	FALSE;
}


int
WinManager( inf, title, mode )
SUBINF	*inf;
char	*title;
int	mode;
{
	EventInfo	myinfo;
	WindowID	cwp, nwp;

	strcpy( inf->subtitle, title );
	inf->OnSwitch= mode;
	inf->WinOnNum = 0;

	{
		int	x, y;
		int	wx= HS_WindowGetSizeX( inf->SubWinBase ) - 216;

		WindowGetScreenPosition( inf->SubWinBase, &x, &y );
		if( wx < 50 )	wx= 50;
		cwp= WindowSimpleOpen( x + wx, y + WINDOW_Y, 150, 204 + 14, NULL, WinExec );
	}
	MS_CURON();
	WindowSetClientData( cwp, 0, inf );
	WindowScrollOpen( 0, 0 + 14, 150, 184, cwp, 150,
				(inf->WinMax * FONT_V < 180)? 180:(inf->WinMax * FONT_V),
				DirectionY, 16, FONT_V, WinScExec );
	WindowRedraw( cwp );
	for(;;){
/*		if( !WindowGetEventInfo( &myinfo ) )	continue;*/
		WindowGetEventInfo( &myinfo );
		nwp= WindowGetChild( WindowRootID, &myinfo );
		if( myinfo.option == EventKey && ( nwp == cwp || nwp == inf->SubWinBase ) ){
			if( myinfo.KeyCode == '\r' ){
				break;	/* RET */
			}else if( myinfo.KeyCode == '\x1b' || myinfo.KeyCode == '\x07' ){
				inf->TargetMen= -1;
				break;	/* ESC */
			}else {
				WindowSendEvent( cwp, &myinfo );
			}
		}else if( nwp == cwp ){
			if( myinfo.option == EventClose ){
				inf->TargetMen= -1;
				break;
			}
			if( myinfo.LeftON && myinfo.y >182 + 4 + 14
					&& myinfo.y < 197 + 4 + 14 ){
				if( myinfo.x > 16 && myinfo.x < 55 ){
					break;	/* OK */
				}else if( myinfo.x > 96 && myinfo.x < 135 ){
					inf->TargetMen= -1;
					break;	/* Cancel */
				}
			}else {
				WindowSendEvent( cwp, &myinfo );
			}
		}else if( nwp != inf->SubWinBase ){
			WindowSendEvent( nwp, &myinfo );
		}
	}
	WindowClose( cwp );
	return inf->TargetMen;
}
