* NO_APP
RUNS_HUMAN_VERSION	equ	3
	.cpu	68000
	.include	doscall.mac
* X68 GCC Develop

	.even
	.text

	.even
_mailcmp:
	move.l	70(a0),d0
	sub.l	70(a1),d0	*year_v
	bne	@f

	move.l	74(a0),d0	*time_v
	sub.l	74(a1),d0
@@
	rts

	.even
	.globl	_pqsort
_pqsort:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	movea.l	4+9*4(sp),a6	*Mail
	move.l	8+9*4(sp),d3	*n
	asl.l	#2,d3
	move.l	d3,d0
	add.l	d0,d0		*stack size = n * 8
	move.l	d0,-(sp)
	DOS	__MALLOC
	tst.l	d0
	addq.w	#4,sp
	bge	@f

	moveq.l	#-1,d0		*out of memmory
	bra	end_pqsort
@@
	move.l	d0,d7		*stack
	movea.l	d0,a5		*stack
	moveq.l	#0,d1
	move.l	d1,(a5)+	*stack[0].low = 0
	subq.l	#1*4,d3
	move.l	d3,(a5)+	*stack[0].high = n - 1
	lea.l	_mailcmp(OPC),a2
lp_qsort:
	move.l	-(a5),d5	*right = stack[sp].high
	move.l	-(a5),d6	*left = stack[sp].low
	move.l	d6,d0		*left
	sub.l	d5,d0		*left >= righ ?
	bge	ent_qsort

	moveq.l	#-20,d1		*INSSORT_BORDER
	cmp.l	d1,d0		*right - left <= INSSORT_BORDER ?
	bge	inssort

	move.l	d6,d3		*left
	subq.l	#1*4,d3		*i = left - 1
	move.l	d5,d4		*right
	addq.l	#1*4,d4		*j = right + 1
	move.l	d6,d0		*left
	add.l	d5,d0		*left + right
*	bpl	@f

*	addq.l	#1,d0
*@@
	asr.l	#1,d0		*(left + right) / 2
	andi.b	#$fc,d0
	move.l	(a6,d0.l),d1	*s = a[(left + right) / 2]
	move.l	(a6,d6.l),d2	*lo = a[left]
	movea.l	(a6,d5.l),a4	*hi = a[right]
	movea.l	d2,a1		*lo
	movea.l	d1,a0		*s
	jsr	(a2)
	bge	@f

	exg.l	d1,d2		*swap(s, lo)
	movea.l	d1,a0		*s
@@
	movea.l	a4,a1		*hi
	jsr	(a2)
	ble	@f

	move.l	a4,d1		*swap(s, hi)
	movea.l	d2,a1		*lo
	movea.l	d1,a0		*s
	jsr	(a2)
	bge	@f

	move.l	d2,d1		*swap(s, lo)
@@
	lea.l	(a6,d4.l),a3	*&(a[j])
	lea.l	(a6,d3.l),a4	*&(a[i])
lp_big:
	movea.l	d1,a1		*s
lp_small1:
	addq.w	#4,a4		*++i
	addq.l	#1*4,d3		*
	movea.l	(a4),a0		*a[i]
	jsr	(a2)
	blt	lp_small1

lp_small2:
	subq.l	#1*4,d4		*--j
	movea.l	-(a3),a0	*a[j]
	jsr	(a2)
	bgt	lp_small2

	cmp.l	d3,d4
	ble	break_big

	move.l	(a4),d0		*swap(a[i], a[j])
	move.l	(a3),(a4)
	move.l	d0,(a3)
	bra	lp_big
break_big:
	addq.l	#1*4,d4		*j + 1
	move.l	d4,(a5)+	*stack[sp].low = j + 1
	move.l	d5,(a5)+	*stack[sp].high = right
	move.l	d6,(a5)+	*stack[sp].low = left 
	subq.l	#1*4,d3		*i - 1
	move.l	d3,(a5)+	*stack[sp].high = i - 1
	bra	ent_qsort
inssort:
	move.l	d6,d3		*left
	addq.l	#1*4,d3		*i = left + 1
	lea.l	(a6,d3.l),a3	*a + i
	bra	ent_ins
lp_ins:
	movea.l	(a3)+,a1	*s = a[i]
	move.l	d3,d4		*j = i
	bra	ent_ascend
lp_ascend:
	move.l	(a6,d4.l),a0	*a[j]
	jsr	(a2)
	ble	break_ascend

	move.l	a0,4(a6,d4.l)	*a[j + 1] = a[j]
ent_ascend:
	subq.l	#1*4,d4		*j--
	cmp.l	d4,d6		*j >= left ?
	ble	lp_ascend
break_ascend:
	move.l	a1,4(a6,d4.l)	*a[j + 1] = s
	addq.l	#1*4,d3		*++i
ent_ins:
	cmp.l	d5,d3		*right >= i ?
	ble	lp_ins
ent_qsort:
	cmp.l	d7,a5		*sp > 0 ?
	bgt	lp_qsort

	move.l	d7,-(sp)
	DOS	__MFREE
	addq.w	#4,sp
	moveq.l	#0,d0
end_pqsort:
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts

	.even
	.end
